;HIRES2.PRG
;von M. Rogge, 29.3.1994, 19.5.94
;Schaltet die hohe Auflsung des Eprom-Sequencers ber PSG IOA6 ein,
;falls Phystop korrekt gesetzt ist. Version fr 4 MByte Speicher.
;Das Programm sollte hinter allen Trap2-Verbiegern im Autoordner stehen,
;aber auf jeden Fall vor MiNT. 
;Neu: Bildschirm wird sofort umgeschaltet, switch ist zweimal vorhanden.
;Einmal mit Timer B fr unmodifizierte Rechner und einmal mit 
;MFP-Portbit 3 fr Rechner, in denen dort VBLANK anliegt. Das ist ohnehin
;eine sinnvolle Modifikation (zur Synchronisation des VBL-Interrupts).
;Die erwnschte Version mu entkommentiert werden.
;
gemdos		= 1
xbios		= 14
hitpa		= 4
baspag		= 4
VRES		= 480
HRES		= 832
SIZE		= $C400	; eigentlich ist HRES*VRES/8 = $C300, aber
			; SIZE mu Vielfaches von 512 sein.
TOP		= $400000
NEWMEMTOP	= TOP-SIZE
NEWPHYSTOP	= NEWMEMTOP+$8000
		;
v_bas_ad	= $44e
phystop 	= $42e
memtop		= $436
		;
		code
start:		bra	install
		;
;
;	Der neue Traphandler dient nur zum Abfangen von v_opnwk().
;
		dc.b	"XBRANEWV"
oldtrap:	dc.l	0
mytrap:		cmp.w	#$73,d0
		bne.s	normtrap
		move.l	d1,a0
		move.l	12(a0),intout
		move.l	(a0),a0
		cmp.w	#1,(a0)
		bne.s	normtrap
		move.l	2(sp),back
		move.l	#patch,2(sp)
normtrap:	move.l	oldtrap(pc),a0
		jmp	(a0)
		;
;
;	patch modifiziert die Rckgabewerte von v_opnwk(). 
;	Alles brige wird durch die Line-A-Variablen geregelt.
;
patch:		bsr.s	modify
		move.l	intout(pc),a0
		move.w	#HRES-1,(a0)+
		move.w	#VRES-1,(a0)
		move.l	back(pc),a0
		jmp	(a0)
		;
;
;	modify setzt die Line-A-Variablen.
;
modify:		dc.w	$a000
		move.w	#VRES,-4(a0)
		move.w	#VRES-1,d0
		move.w	d0,-$2b2(a0)
		move.w	-$2e(a0),d1
		divu	d1,d0
		move.w	d0,-$2a(a0)
		;
		move.w	#HRES-1,-$2b4(a0)
		move.w	#HRES,d0
		move.w	d0,-$c(a0)
		lsr.w	#3,d0
		subq.w	#1,d0
		move.w	d0,-$2c(a0)
		addq.w	#1,d0
		move.w	d0,-2(a0)
		move.w	d0,2(a0)
		mulu	d1,d0
		move.w	d0,-$28(a0)
		rts
		;
intout:		dc.l	0
back:		dc.l	0
		;
;
;	switch schaltet die hohe Auflsung ein
;	Version fr den modifizierten ST
;
switch:		moveq	#0,d0
		lea	NEWPHYSTOP,a0
		move.w	#SIZE/4-$2001,d1
clrlp:		move.l	d0,(a0)+
		dbra	d1,clrlp
		;
		move.w	#2,-(sp)
		lea	NEWMEMTOP,a0
		pea	(a0)
		pea	(a0)
		move.w	#5,-(sp)
		trap	#14
		lea	12(sp),sp
		;
		move	sr,d1
		or.w	#$700,sr
		;
		lea	$fffffa01.w,a0
wait4:		btst	#3,(a0)
		bne.s	wait4
		;
		move.b	#$e,$ffff8800.w
		move.b	$ffff8800.w,d0
		bset	#6,d0		; IOA6 des Soundchips
		move.b	d0,$ffff8802.w
		;
		move	d1,sr
  		rts
		;
;
;	switch schaltet die hohe Auflsung ein
;	Version fr den Standard-ST
;
;switch:	moveq	#0,d0
;		lea	NEWPHYSTOP,a0
;		move.w	#SIZE/4-$2001,d1
;clrlp:		move.l	d0,(a0)+
;		dbra	d1,clrlp
;		;
;		move.w	#2,-(sp)
;		lea	NEWMEMTOP,a0
;		pea	(a0)
;		pea	(a0)
;		move.w	#5,-(sp)
;		trap	#14
;		lea	12(sp),sp
;		;
;		move	sr,-(sp)
;		or.w	#$700,sr
;		;
;		lea	$fffffa21.w,a0
;		lea	$fffffa1b.w,a1
;		move.b	#$10,(a1)
;		moveq	#1,d1
;		move.b	#0,(a1)
;		move.b	#$f0,(a0)
;		move.b	#8,(a1)
;wait1:		move.b	(a0),d0
;		cmp.b	d1,d0
;		bne.s	wait1
;wait2:		move.b	(a0),d0
;		move.w	#600,d1		;ausprobieren
;wait3:		cmp.b	(a0),d0
;		bne.s	wait2
;		dbra	d1,wait3
;		move.b	#$10,(a1)
;		;
;		move.b	#$e,$ffff8800.w
;		move.b	$ffff8800.w,d0
;		bset	#6,d0		; IOA6 des Soundchips
;		move.b	d0,$ffff8802.w
;		;
;  		move	(sp)+,sr
;  		rts
		;
;
;	install steht hinten, da der Speicher freigegeben wird.
;
install:	clr.l	-(sp)
		move.w	#$20,-(sp)	;Super
		trap	#gemdos
		addq.l	#4,sp		;noch Nullwort auf dem Stack
		move.l	phystop.w,d1
		cmp.l	#NEWPHYSTOP,d1
		beq.s	warm
		trap	#gemdos		;Pterm0
		;
warm:		move.l	$88.w,oldtrap
		move.l	#mytrap,$88.w
		bsr	switch
		bsr	modify
		pea	256+switch-start
		move	#$31,-(sp)	;Ptermres
		trap	#gemdos
		;

