/* Programm zur Erzeugung des Sequencer-Eproms (bzw. einer entsprechenden
   Datei) fr den 10/12-MHz-Umbau aus ST-Computer 9/1992.
   
   Originalversion in Basic von Michael Steinle, (c)1992 Maxon Computer.
   C-Version von Martin Rogge.
*/

#include <stdio.h>
#include <stdlib.h>

#define HSYNC	1
#define VSYNC	2
#define DE		4
#define BLANK	8

#define FILENAME "sequencr.img"

typedef unsigned char byte;

byte eprom[32768L];

void fill_eprom(int abh, int hs, int bish, int h, 
				int abv, int vs, int bisv, int v)
{	register byte *bp;
	register int vz, hz;

	abh>>=5;
	hs>>=5;
	bish>>=5;
	h>>=5;
	bp=eprom;
	for (vz=abv; vz!=0; vz--)
	{	for (hz=abh+hs+bish; hz !=0; hz--)
			*bp++=HSYNC|VSYNC;
		for (hz=h; hz !=0; hz--)
			*bp++=VSYNC;
	}
	for (vz=vs; vz!=0; vz--)
	{	for (hz=abh; hz !=0; hz--)
			*bp++=HSYNC|VSYNC;
		for (hz=hs; hz !=0; hz--)
			*bp++=HSYNC|VSYNC|BLANK|DE;
		for (hz=bish; hz !=0; hz--)
			*bp++=HSYNC|VSYNC;
		for (hz=h; hz !=0; hz--)
			*bp++=VSYNC;
	}
	for (vz=bisv; vz!=0; vz--)
	{	for (hz=abh+hs+bish; hz !=0; hz--)
			*bp++=HSYNC|VSYNC;
		for (hz=h; hz !=0; hz--)
			*bp++=VSYNC;
	}
	for (vz=v; vz!=0; vz--)
	{	for (hz=abh+hs+bish+h; hz !=0; hz--)
			*bp++=HSYNC;
	}
	for (vz=(int)((eprom+32768L)-bp); vz!=0; vz--)
		*bp++=0xFF;
}

int main(void)
{	FILE *datei;

	datei=fopen(FILENAME,"wb");
	if (datei==NULL)
		return -1;
	fill_eprom(192,640,160,128,50,400,49,2); /* 640*400 Punkte bei 10 MHz */
	fwrite(eprom,1L,32768L,datei);
	fill_eprom(64,832,96,128,18,480,1,2);	/* 832*480 Punkte bei 10 MHz */
	fwrite(eprom,1L,32768L,datei);
	fclose(datei);
	return 0;
}
